package net.mysoftworks.modulecompiler.model.meta;


import net.mysoftworks.modulecompiler.model.values.RawValue;
import net.mysoftworks.modulecompiler.model.visitor.MetaFieldVisitor;

import javax.persistence.*;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;

/**
 * MetaTemporalField generated by hbm2java
 */
@Entity
@DiscriminatorValue("TEMPORAL")
public class MetaTemporalField extends MetaField implements java.io.Serializable {
	private static final long serialVersionUID = 1L;

	@Column(name="SUB_TYPE")
	@Enumerated(EnumType.STRING)
	private TemporalType temporalType= TemporalType.DATE;

	@Column(name="INTERV_DA")
	@Temporal(TemporalType.TIMESTAMP)
	private Calendar intDa;

	@Column(name="INTERV_A")
	@Temporal(TemporalType.TIMESTAMP)
	private Calendar intA;

	@Column(name="IN_RANGE")
	private boolean inRange = true;

	public MetaTemporalField(){super(BUSINESS_FIELD_TYPE.TEMPORAL);	}
	public MetaTemporalField(MetaTemporalField source) {
		super(source);
		this.temporalType = source.temporalType;
	}
	public TemporalType getTemporalType() {
		return temporalType;
	}

	@Override
	public String toString() {
		final StringBuilder sb = new StringBuilder("MetaTemporalField{");
		sb.append("temporalType=").append(temporalType);
		sb.append("intDa=").append(intDa);
		sb.append("intA=").append(intA);
		sb.append("inRange=").append(inRange);
		sb.append('}').append(super.toString());
		return sb.toString();
	}

	public void setTemporalType(TemporalType temporalType) {
		this.temporalType = temporalType;
	}

	public Calendar getIntDa() {
		return intDa;
	}

	public void setIntDa(Calendar intDa) {
		this.intDa = intDa;
	}

	public Calendar getIntA() {
		return intA;
	}

	public void setIntA(Calendar intA) {
		this.intA = intA;
	}

	public boolean isInRange() {
		return inRange;
	}

	public void setInRange(boolean inRange) {
		this.inRange = inRange;
	}

	public void accept(MetaFieldVisitor visitor) {
		visitor.visit(this);
	}

	@Override
	public Object viewValue(RawValue rawValue) {
		if (rawValue==null) return null;
		Calendar cal = rawValue.getDateValue();
		if (cal==null) return null;
		java.util.Date date = cal.getTime();
		DateFormat format1 = null;
		if (TemporalType.DATE.equals(temporalType)) {
			format1 = new SimpleDateFormat("dd-MM-yyyy");
		}
		if (TemporalType.TIME.equals(temporalType)) {
			format1 = new SimpleDateFormat("hh:mm");
		}
		if (TemporalType.TIMESTAMP.equals(temporalType)) {
			format1 = new SimpleDateFormat("dd-MM-yyyy hh:mm");
		}
		return format1.format(date);
	}
	@Override
	public Object editValue(RawValue rawValue){
		if (rawValue==null) return null;
		if (rawValue.getDateValue()==null) {
			rawValue.setDateValue(Calendar.getInstance());
		}
		return rawValue.getDateValue();
	}


}
